#########################################################
#                                                       #
#       SIMPLE GENETIC ALGORITHM (02.09.2019)           #
#                  &                                    #
#      MOUSE ARTIFICIAL IMMUNE SYSTEM                   #
#      (DENDRITIC SYSTEM: nonself-danger)               #
#                                                       #
#              R. Lahoz-Beltra                          #
#                                                       #    
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND   #
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT #
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY #
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  #
# THE SOFWTARE CAN BE USED BY ANYONE SOLELY FOR THE     #
# PURPOSES OF RESEARCH AND EDUCATION.                   #
#                                                       #
#########################################################
import random
from random import randint
import numpy as np
import matplotlib.pyplot as plt
import mais as m
#########################################################
# ALGORITHM PARAMETERS                                  #
#########################################################
N= 80                # Population size
Genome= 64           # Genome length 

#########################################################
# VARIABLES ALGORITHM                                   #
#########################################################
popSize = N+1
genomeLength  = Genome+1
# init best chromosome
the_best_chrom=0;         
# fitness                                  
fitness = np.empty([popSize])                               
 # probability
probability = np.empty([popSize])                          
net = np.empty([popSize])
# chromosomes
chromosome = np.empty([popSize, genomeLength],dtype=np.int) 
nchromosome = np.empty([popSize, genomeLength],dtype=np.int)
child1 = np.empty([popSize, genomeLength],dtype=np.int)     
child2 = np.empty([popSize, genomeLength],dtype=np.int) 
  
import sys
RNAtarget= np.empty([100],dtype=np.int) 

#########################################################
# POPULATION INITIALIZATION                             #
#########################################################
def Init_population():
    for i in range(1,popSize):
        for j in range(1,genomeLength):
            allele=np.random.random_integers(100)
            allele=allele/100
            if allele<=0.5:
                chromosome[i,j]=0
            else:
                chromosome[i,j]=1


#########################################################
# SHOW POPULATION                                       #
#########################################################
def Show_population():
    for i in range(1,popSize):
        for j in range(1,genomeLength):
            print(chromosome[i,j],end="")
        print()

#########################################################
# FITNESS EVALUATION                                    #
#########################################################         
def Fitness_evaluation(filename, generation, neutrarate):
    # fitness evaluation
    w=1000;
    i=1; j=1; fitness_total=0; 
    fitness_average=0; 
    
 ########################################################
    if m.stop[0]==1:
        for i in range(1,popSize):
            u=np.random.random_integers(100)
            u=u/100
            if u<=neutrarate:    # NEUTRALIZATION RATE
                fitness[i]=0
            else:
                S_1=0; S_2=0; S_3=0;
                fitness[i]=0.01*w;
                genome_l=40; genome_r=43; 
                for j in range(genome_l,genome_r+1): 
                    if chromosome[i,j]==RNAtarget[j]:
                        S_1+=1
                        #print("Similarity = ",S_1)
       
                genome_l=44; genome_r=47;
                for j in range(genome_l,genome_r+1):
                    if chromosome[i,j]==RNAtarget[j]:
                        S_2+=1
                        #print("Similarity = ",S_2)
                
                genome_l=48; genome_r=51;
                for j in range(genome_l,genome_r+1):
                    if chromosome[i,j]==RNAtarget[j]:
                        S_3+=1
                        #print("Similarity = ",S_3)
                
                if S_1==0 or S_2==0 or S_3==0:
                    fitness[i]=0.33*w
                if (S_1==0 and S_2==0) or (S_1==0 and S_3==0) or (S_2==0 and S_3==0):
                    fitness[i]=0.67*w
                if S_1==0 and S_2==0 and S_3==0:
                    fitness[i]=1.00*w
                S_1=0; S_2=0; S_3=0;   
                print("Fitness virus [",i,"] = ",fitness[i], end="")
  
                fitness_total=fitness_total+fitness[i] 
        fitness_average=fitness_total/popSize
        # Statistical output                                    
        f = open(filename, "a")
        f.write(str(generation)+" "+str(fitness_average)+"\n")
        f.write(" \n")
        f.close()
        print("Population size = ", popSize - 1)
        print("mean fitness = ",fitness_average)
    
    else:
        # Bocharov et al. (2005) Journal of General Virology 86, 3109-3118
        # Hamming and Similarity coefficients   
        S_1=0; S_2=0; S_3=0;
        for i in range(1,popSize):
            fitness[i]=0.01*w;
            genome_l=40; genome_r=43; 
            for j in range(genome_l,genome_r+1): 
                if chromosome[i,j]==RNAtarget[j]:
                    S_1+=1
                    #print("Similarity = ",S_1)
       
            genome_l=44; genome_r=47;
            for j in range(genome_l,genome_r+1):
                if chromosome[i,j]==RNAtarget[j]:
                    S_2+=1
                    #print("Similarity = ",S_2)
                
            genome_l=48; genome_r=51;
            for j in range(genome_l,genome_r+1):
                if chromosome[i,j]==RNAtarget[j]:
                    S_3+=1
                    #print("Similarity = ",S_3)
                
            if S_1==0 or S_2==0 or S_3==0:
                fitness[i]=0.33*w
            if (S_1==0 and S_2==0) or (S_1==0 and S_3==0) or (S_2==0 and S_3==0):
                fitness[i]=0.67*w
            if S_1==0 and S_2==0 and S_3==0:
                fitness[i]=1.00*w
        
            S_1=0; S_2=0; S_3=0;   
    
def evaluation(filename, generation, neutrarate, minfitave):
    Fitness_evaluation(filename, generation, neutrarate)
    fitness_average=0; 
    for i in range(1,popSize):
        print("Fitness virus [",i,"] = ",fitness[i], end="")
        fitness_average=fitness_average+fitness[i]
    fitness_average=fitness_average/popSize
    # Statistical output   
    f = open(filename, "a")
    f.write(str(generation)+" "+str(fitness_average)+"\n")
    f.write(" \n")
    f.close()
    print("Population size = ", popSize - 1)
    print("mean fitness = ",fitness_average)

    if fitness_average<=minfitave:  # MINIMUM FITNESS AVERAGE
         sys.exit("bye ... virus ")

#########################################################
# TOURNAMENT SELECTION OPERATOR                         #
#########################################################
def select_p_tournament():
    u1=0; u2=0; parent=99;
    while (u1==0 and u2==0):
        u1=np.random.random_integers(popSize-1)
        u2=np.random.random_integers(popSize-1)
        if fitness[u1] >= fitness[u2]:
            parent = u1
        else:
            parent = u2
    return parent

#########################################################
# WHEEL PARENTS SELECTION OPERATOR                      #
#########################################################
def wheel_p_selection():
    fitness_total=0; parent=0;
    for i in range(1,popSize):
        fitness_total = fitness_total + fitness[i]
    for i in range(1,popSize):
        probability[i]=fitness[i]/fitness_total
    for i in range(1,popSize):
        net[0]=0
    for i in range(1,popSize):
        net[i]=net[i-1]+probability[i]
    u=np.random.uniform(0,1)
    bugs=1; k=1;
    while bugs<=popSize-1:
        for i in range(1,popSize):
            if u<net[i]:
                parent=i
                for j in range(1,genomeLength):
                    nchromosome[k,j]=chromosome[parent,j]
                k=k+1
                break
        u=np.random.uniform(0,1)   
        bugs=bugs+1
    for i in range(1,popSize):
        for j in range(1,genomeLength):
            chromosome[i,j]=nchromosome[i,j]

#########################################################
# FLIP BIT MUTATION OPERATOR                            #
#########################################################
# pop_mutation_rate: mutation rate in the population
# mutation_rate: probability of a mutation of a bit 
def mutation(pop_mutation_rate, mutation_rate):
    for i in range(1,popSize):
        up=np.random.random_integers(100)
        up=up/100
        if up<=pop_mutation_rate:
            for j in range(1,genomeLength):
                um=np.random.random_integers(100)
                um=um/100
                if um<=mutation_rate:
                    if chromosome[i,j]==0:
                        nchromosome[i,j]=1
                    else:
                        nchromosome[i,j]=0
                else:
                    nchromosome[i,j]=chromosome[i,j]
        else:
            for j in range(1,genomeLength):
                nchromosome[i,j]=chromosome[i,j]
    for i in range(1,popSize):
        for j in range(1,genomeLength):
            chromosome[i,j]=nchromosome[i,j]
            
########################################################
# ONE-POINT CROSSOVER                                  #
########################################################  
# crossover_rate: setup crossover rate
def mating(crossover_rate):
    j=0;
    crossover_point=0;
    parent1=select_p_tournament()
    parent2=select_p_tournament()
    if random.random()<=crossover_rate:
        crossover_point = np.random.random_integers(genomeLength-2)
    j=1; 
    while (j<=genomeLength-1):
        if j<=crossover_point:
            child1[parent1,j]=chromosome[parent1,j]
            child2[parent2,j]=chromosome[parent2,j]
        
        else:
            child1[parent1,j]=chromosome[parent2,j]
            child2[parent2,j]=chromosome[parent1,j]
        j=j+1
        
    j=1
    for j in range(1,genomeLength):
        chromosome[parent1,j]=child1[parent1,j]
        chromosome[parent2,j]=child2[parent2,j]
  
def crossover(crossover_rate):
    c=1;
    while (c<=N):
        mating(crossover_rate)
        c=c+1

#########################################################
# PERFORMANCE GRAPH                                     #
#########################################################
# Read the Docs in http://matplotlib.org/1.4.1/index.html
def plot_Output(filename,xmax,ymax):
    data = np.loadtxt(filename)
    # plot the first column as x, and second column as y
    x=data[:,0]
    y=data[:,1]
    # (x,y,'ro') plot only points
    plt.plot(x,y)          
    plt.xlabel('Generation')       
    plt.ylabel('Fitness average')
    # set up max number of generations
    plt.xlim(0, xmax)    
    # set up max fitness value
    plt.ylim(0, ymax)    
    plt.show() 
    
def sGA(generation, filename):
    print("============== GENERATION: ",generation," =========================== ")
    print()
    Init_population()
    Show_population()
    Fitness_evaluation(filename, generation, neutrarate)
    while (generation<generation_max-1):
        print()
        print("============== GENERATION: ",generation+1," =========================== ")
        print()
        # Select virus, update generation and calculates fitness
        wheel_p_selection()
        generation=generation+1
        # Apply genetic operators  
        # crossover(0.75)
        mutation(0.1,0.3)
        m.dDetection('RNAHIV.dat','rat.dat','1001', 10, 100, generation)
        evaluation(filename, generation, neutrarate, minfitave)
       
        

#########################################################
#                                                       #
# MAIN PROGRAM                                          #
#                                                       #
#########################################################
print("SIMPLE GENETIC ALGORITHM & MOUSE ARTIFICIAL IMMUNE SYSTEM")
print("DENDRITIC SYSTEM: nonself-danger")
input("Press Enter to continue...")

# Virus entrance
m.RNA('RNAHIV.dat');

# Genetic algorithm
generation=0
# Maximum of generations - iterations
generation_max= 200
# Neutralization rate & minimum average fitness survivability 
neutrarate=0.99; minfitave=200;

sGA(generation, 'output.dat')

'''
# Output performance graphs
plot_Output('B-cells.dat',100,170)
plot_Output('output.dat',250,1100)
'''




